<?php

require_once('/usr/fallback/beroConf.php');
require_once('/usr/local/www/berogui/misc/database.php');
require_once('/usr/local/www/berogui/includes/password_func.php');

class apiCall {

	private $_name, $_get, $_post, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'GatewaySetPassword';
		$this->_get = $get;
		$this->_post = $post;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		if (!isset($this->_get['OldPassword']) || empty($this->_get['OldPassword'])) {
			$this->_execResultString = 'error:parameter_OldPassword_missing';
			$this->_execResult = false;
			return($this->_execResult);
		}

		if (!isset($this->_get['NewPassword']) || empty($this->_get['NewPassword'])) {
			$this->_execResultString = 'error:parameter_NewPassword_missing';
			$this->_execResult = false;
			return($this->_execResult);
		}

		// validate old password against current gui-password
		$ba = new beroAri('/usr/conf/ari.db');
		$res = $ba->select('SELECT password FROM users WHERE user = \'admin\';');
		$oldDbPassword = $ba->fetch_array($res);
		unset($res);

		if (!tep_validate_password($this->_get['OldPassword'], $oldDbPassword['password'])) {
			$this->_execResultString = 'error:parameter_OldPassword_does_not_match';
			$this->_execResult = false;
			return($this->_execResult);
		}

		// update gui-password
		$ba->update('UPDATE users SET password = \'' . tep_encrypt_password($this->_get['NewPassword']) . '\' WHERE user = \'admin\'');

		// update api-password
		$apiUsers = file_get_contents('/usr/conf/apiusers.conf');

		// preserve line of user provisioning
		preg_match('/(.*provisioning:[0-9a-zA-Z]*)/', $apiUsers, $matches);
		$provisioningLine = $matches[1];
		unset($matches);

		// create new password for user admin
		$newPasswordEnc = crypt($this->_get['NewPassword'], base64_encode($this->_get['NewPassword']));

		// write new apiusers.conf
		$apiUsersNew = 'admin:' . $newPasswordEnc . "\n" . $provisioningLine . "\n";
		file_put_contents('/usr/conf/apiusers.conf', $apiUsersNew);

		// update ssh-password
		exec('/usr/local/sbin/pwchange.sh admin ' . $this->_get['NewPassword']);

		// if ssh-user was disabled, disable him again
		$bc = new beroConf('root');
		if ($bc->get('root', 'ssh_admin_enable') != '1') {
			exec('/bin/mount -oremount,rw /; /usr/bin/passwd -l admin; sync; /bin/mount -oremount,ro /');
		}

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . ($this->_execResult ? 'success' : $this->_execResultString));
	}
}

?>
