<?php

include('/usr/local/www/berogui/misc/database.php');
require_once('/usr/fallback/beroConf.php');
require_once('/usr/local/www/berogui/includes/Helper/Helper.php');

class apiCall {

	private $_name, $_get, $_post, $_files, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'NetworkSetSnmp';
		$this->_get = $get;
		$this->_post = $post;
		$this->_files = $files;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		$validSetting = false;

		$bc = new beroConf('root');

		if (isset($this->_get['Mode']) && in_array($this->_get['Mode'], array('enabled', 'disabled'))) {
			$bc->set('root', 'snmp-enabled', (($this->_get['Mode'] == 'enabled') ? 1 : 0));
			$validSetting = true;
		}

		if (isset($this->_get['DeviceLocation'])) {
			$bc->set('root', 'snmp-syslocation', sqlite_escape_string($this->_get['DeviceLocation']));
			$validSetting = true;
		}

		if (isset($this->_get['RoCommunity'])) {
			$bc->set('root', 'snmp-community-ro', sqlite_escape_string($this->_get['RoCommunity']));
			$validSetting = true;
		}

		if (isset($this->_get['RwCommunity'])) {
			$bc->set('root', 'snmp-community-rw', sqlite_escape_string($this->_get['RwCommunity']));
			$validSetting = true;
		}

		if (isset($this->_get['TrapCommunity'])) {
			$bc->set('root', 'snmp-community-trap', sqlite_escape_string($this->_get['TrapCommunity']));
			$validSetting = true;
		}

		if (isset($this->_get['TrapSink'])) {
			$bc->set('root', 'snmptraps_sink', sqlite_escape_string($this->_get['TrapSink']));
			$validSetting = true;
		}

		if (isset($this->_get['TrapInterval'])) {
			$bc->set('root', 'snmptraps_intervall', sqlite_escape_string($this->_get['TrapInterval']));
			$validSetting = true;
		}

		if (isset($this->_get['Traps'])) {

			$trapsString = '';

			if ($this->_get['Traps'] == 'IsdnLayer2') {
				$trapsString .= ((strlen($trapsString) == 0) ? '' : ',') . 'snmptrap_isdnl2';
			}

			$bc->set('root', 'snmptraps', $trapsString);
			$validSetting = true;
		}

		if ($validSetting == false) {
			$this->_execResultString = 'error:invalid_parameters';
			$this->_execResult = false;
			return($this->_execResult);
		}

		Helper::activate(2);

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}
}

?>
